/* unity-lens-search.c generated by valac 0.12.1, the Vala compiler
 * generated from unity-lens-search.vala, do not modify */

/*
 * Copyright (C) 2011 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include "unity.h"
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _UnityLensSearchPrivate {
	gchar* _search_string;
	GHashTable* _hints;
};


static gpointer unity_lens_search_parent_class = NULL;

#define UNITY_LENS_SEARCH_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), UNITY_TYPE_LENS_SEARCH, UnityLensSearchPrivate))
enum  {
	UNITY_LENS_SEARCH_DUMMY_PROPERTY,
	UNITY_LENS_SEARCH_SEARCH_STRING,
	UNITY_LENS_SEARCH_HINTS
};
static void unity_lens_search_finalize (GObject* obj);
static void _vala_unity_lens_search_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_unity_lens_search_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


UnityLensSearch* unity_lens_search_construct (GType object_type, const gchar* search_string, GHashTable* hints) {
	UnityLensSearch * self = NULL;
	g_return_val_if_fail (search_string != NULL, NULL);
	g_return_val_if_fail (hints != NULL, NULL);
	self = (UnityLensSearch*) g_object_new (object_type, "search-string", search_string, "hints", hints, NULL);
	return self;
}


UnityLensSearch* unity_lens_search_new (const gchar* search_string, GHashTable* hints) {
	return unity_lens_search_construct (UNITY_TYPE_LENS_SEARCH, search_string, hints);
}


gboolean unity_lens_search_equals (UnityLensSearch* self, UnityLensSearch* other) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (other == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (self->priv->_search_string, other->priv->_search_string) != 0;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


const gchar* unity_lens_search_get_search_string (UnityLensSearch* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_search_string;
	return result;
}


static void unity_lens_search_set_search_string (UnityLensSearch* self, const gchar* value) {
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_search_string);
	self->priv->_search_string = _tmp0_;
	g_object_notify ((GObject *) self, "search-string");
}


GHashTable* unity_lens_search_get_hints (UnityLensSearch* self) {
	GHashTable* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_hints;
	return result;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


static void unity_lens_search_set_hints (UnityLensSearch* self, GHashTable* value) {
	GHashTable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_hash_table_ref0 (value);
	_g_hash_table_unref0 (self->priv->_hints);
	self->priv->_hints = _tmp0_;
	g_object_notify ((GObject *) self, "hints");
}


static void unity_lens_search_class_init (UnityLensSearchClass * klass) {
	unity_lens_search_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (UnityLensSearchPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_unity_lens_search_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_unity_lens_search_set_property;
	G_OBJECT_CLASS (klass)->finalize = unity_lens_search_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), UNITY_LENS_SEARCH_SEARCH_STRING, g_param_spec_string ("search-string", "search-string", "search-string", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), UNITY_LENS_SEARCH_HINTS, g_param_spec_boxed ("hints", "hints", "hints", G_TYPE_HASH_TABLE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_signal_new ("finished", UNITY_TYPE_LENS_SEARCH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void unity_lens_search_instance_init (UnityLensSearch * self) {
	self->priv = UNITY_LENS_SEARCH_GET_PRIVATE (self);
}


static void unity_lens_search_finalize (GObject* obj) {
	UnityLensSearch * self;
	self = UNITY_LENS_SEARCH (obj);
	_g_free0 (self->priv->_search_string);
	_g_hash_table_unref0 (self->priv->_hints);
	G_OBJECT_CLASS (unity_lens_search_parent_class)->finalize (obj);
}


GType unity_lens_search_get_type (void) {
	static volatile gsize unity_lens_search_type_id__volatile = 0;
	if (g_once_init_enter (&unity_lens_search_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityLensSearchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) unity_lens_search_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UnityLensSearch), 0, (GInstanceInitFunc) unity_lens_search_instance_init, NULL };
		GType unity_lens_search_type_id;
		unity_lens_search_type_id = g_type_register_static (G_TYPE_INITIALLY_UNOWNED, "UnityLensSearch", &g_define_type_info, 0);
		g_once_init_leave (&unity_lens_search_type_id__volatile, unity_lens_search_type_id);
	}
	return unity_lens_search_type_id__volatile;
}


static void _vala_unity_lens_search_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	UnityLensSearch * self;
	self = UNITY_LENS_SEARCH (object);
	switch (property_id) {
		case UNITY_LENS_SEARCH_SEARCH_STRING:
		g_value_set_string (value, unity_lens_search_get_search_string (self));
		break;
		case UNITY_LENS_SEARCH_HINTS:
		g_value_set_boxed (value, unity_lens_search_get_hints (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_unity_lens_search_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UnityLensSearch * self;
	self = UNITY_LENS_SEARCH (object);
	switch (property_id) {
		case UNITY_LENS_SEARCH_SEARCH_STRING:
		unity_lens_search_set_search_string (self, g_value_get_string (value));
		break;
		case UNITY_LENS_SEARCH_HINTS:
		unity_lens_search_set_hints (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



