/* unity-scope-proxy.c generated by valac 0.12.1, the Vala compiler
 * generated from unity-scope-proxy.vala, do not modify */

/*
 * Copyright (C) 2011 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <dee.h>


#define UNITY_TYPE_SCOPE_PROXY (unity_scope_proxy_get_type ())
#define UNITY_SCOPE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNITY_TYPE_SCOPE_PROXY, UnityScopeProxy))
#define UNITY_IS_SCOPE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNITY_TYPE_SCOPE_PROXY))
#define UNITY_SCOPE_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UNITY_TYPE_SCOPE_PROXY, UnityScopeProxyIface))

typedef struct _UnityScopeProxy UnityScopeProxy;
typedef struct _UnityScopeProxyIface UnityScopeProxyIface;

#define UNITY_TYPE_ACTIVATION_REPLY_RAW (unity_activation_reply_raw_get_type ())
typedef struct _UnityActivationReplyRaw UnityActivationReplyRaw;

#define UNITY_TYPE_PREVIEW_REPLY_RAW (unity_preview_reply_raw_get_type ())
typedef struct _UnityPreviewReplyRaw UnityPreviewReplyRaw;

struct _UnityActivationReplyRaw {
	gchar* uri;
	guint handled;
	GHashTable* hints;
};

struct _UnityPreviewReplyRaw {
	gchar* uri;
	gchar* renderer_name;
	GHashTable* properties;
};

struct _UnityScopeProxyIface {
	GTypeInterface parent_iface;
	void (*activate) (UnityScopeProxy* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*activate_finish) (UnityScopeProxy* self, GAsyncResult* _res_, UnityActivationReplyRaw* result);
	void (*search) (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*search_finish) (UnityScopeProxy* self, GAsyncResult* _res_);
	void (*global_search) (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*global_search_finish) (UnityScopeProxy* self, GAsyncResult* _res_);
	void (*preview) (UnityScopeProxy* self, const gchar* uri, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*preview_finish) (UnityScopeProxy* self, GAsyncResult* _res_, UnityPreviewReplyRaw* result);
	void (*set_active) (UnityScopeProxy* self, gboolean active, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_active_finish) (UnityScopeProxy* self, GAsyncResult* _res_);
	void (*set_active_sources) (UnityScopeProxy* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_active_sources_finish) (UnityScopeProxy* self, GAsyncResult* _res_);
	gchar** (*get_sources) (UnityScopeProxy* self, int* result_length1);
	void (*set_sources) (UnityScopeProxy* self, gchar** value, int value_length1);
	gboolean (*get_search_in_global) (UnityScopeProxy* self);
	void (*set_search_in_global) (UnityScopeProxy* self, gboolean value);
	DeeSharedModel* (*get_results_model) (UnityScopeProxy* self);
	void (*set_results_model) (UnityScopeProxy* self, DeeSharedModel* value);
	DeeSharedModel* (*get_global_results_model) (UnityScopeProxy* self);
	void (*set_global_results_model) (UnityScopeProxy* self, DeeSharedModel* value);
	DeeSharedModel* (*get_filters_model) (UnityScopeProxy* self);
	void (*set_filters_model) (UnityScopeProxy* self, DeeSharedModel* value);
};



GType unity_activation_reply_raw_get_type (void) G_GNUC_CONST;
UnityActivationReplyRaw* unity_activation_reply_raw_dup (const UnityActivationReplyRaw* self);
void unity_activation_reply_raw_free (UnityActivationReplyRaw* self);
void unity_activation_reply_raw_copy (const UnityActivationReplyRaw* self, UnityActivationReplyRaw* dest);
void unity_activation_reply_raw_destroy (UnityActivationReplyRaw* self);
GType unity_preview_reply_raw_get_type (void) G_GNUC_CONST;
UnityPreviewReplyRaw* unity_preview_reply_raw_dup (const UnityPreviewReplyRaw* self);
void unity_preview_reply_raw_free (UnityPreviewReplyRaw* self);
void unity_preview_reply_raw_copy (const UnityPreviewReplyRaw* self, UnityPreviewReplyRaw* dest);
void unity_preview_reply_raw_destroy (UnityPreviewReplyRaw* self);
GType unity_scope_proxy_get_type (void) G_GNUC_CONST;
void unity_scope_proxy_activate (UnityScopeProxy* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_activate_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityActivationReplyRaw* result);
void unity_scope_proxy_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_search_finish (UnityScopeProxy* self, GAsyncResult* _res_);
void unity_scope_proxy_global_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_global_search_finish (UnityScopeProxy* self, GAsyncResult* _res_);
void unity_scope_proxy_preview (UnityScopeProxy* self, const gchar* uri, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_preview_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityPreviewReplyRaw* result);
void unity_scope_proxy_set_active (UnityScopeProxy* self, gboolean active, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_set_active_finish (UnityScopeProxy* self, GAsyncResult* _res_);
void unity_scope_proxy_set_active_sources (UnityScopeProxy* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_set_active_sources_finish (UnityScopeProxy* self, GAsyncResult* _res_);
gchar** unity_scope_proxy_get_sources (UnityScopeProxy* self, int* result_length1);
void unity_scope_proxy_set_sources (UnityScopeProxy* self, gchar** value, int value_length1);
gboolean unity_scope_proxy_get_search_in_global (UnityScopeProxy* self);
void unity_scope_proxy_set_search_in_global (UnityScopeProxy* self, gboolean value);
DeeSharedModel* unity_scope_proxy_get_results_model (UnityScopeProxy* self);
void unity_scope_proxy_set_results_model (UnityScopeProxy* self, DeeSharedModel* value);
DeeSharedModel* unity_scope_proxy_get_global_results_model (UnityScopeProxy* self);
void unity_scope_proxy_set_global_results_model (UnityScopeProxy* self, DeeSharedModel* value);
DeeSharedModel* unity_scope_proxy_get_filters_model (UnityScopeProxy* self);
void unity_scope_proxy_set_filters_model (UnityScopeProxy* self, DeeSharedModel* value);
static void g_cclosure_user_marshal_VOID__STRING_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);


void unity_scope_proxy_activate (UnityScopeProxy* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->activate (self, uri, action_type, _callback_, _user_data_);
}


void unity_scope_proxy_activate_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityActivationReplyRaw* result) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->activate_finish (self, _res_, result);
}


void unity_scope_proxy_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->search (self, search_string, hints, _callback_, _user_data_);
}


void unity_scope_proxy_search_finish (UnityScopeProxy* self, GAsyncResult* _res_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->search_finish (self, _res_);
}


void unity_scope_proxy_global_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->global_search (self, search_string, hints, _callback_, _user_data_);
}


void unity_scope_proxy_global_search_finish (UnityScopeProxy* self, GAsyncResult* _res_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->global_search_finish (self, _res_);
}


void unity_scope_proxy_preview (UnityScopeProxy* self, const gchar* uri, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->preview (self, uri, _callback_, _user_data_);
}


void unity_scope_proxy_preview_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityPreviewReplyRaw* result) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->preview_finish (self, _res_, result);
}


void unity_scope_proxy_set_active (UnityScopeProxy* self, gboolean active, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_active (self, active, _callback_, _user_data_);
}


void unity_scope_proxy_set_active_finish (UnityScopeProxy* self, GAsyncResult* _res_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_active_finish (self, _res_);
}


void unity_scope_proxy_set_active_sources (UnityScopeProxy* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_active_sources (self, sources, sources_length1, _callback_, _user_data_);
}


void unity_scope_proxy_set_active_sources_finish (UnityScopeProxy* self, GAsyncResult* _res_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_active_sources_finish (self, _res_);
}


gchar** unity_scope_proxy_get_sources (UnityScopeProxy* self, int* result_length1) {
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_sources (self, result_length1);
}


void unity_scope_proxy_set_sources (UnityScopeProxy* self, gchar** value, int value_length1) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_sources (self, value, value_length1);
}


gboolean unity_scope_proxy_get_search_in_global (UnityScopeProxy* self) {
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_search_in_global (self);
}


void unity_scope_proxy_set_search_in_global (UnityScopeProxy* self, gboolean value) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_search_in_global (self, value);
}


DeeSharedModel* unity_scope_proxy_get_results_model (UnityScopeProxy* self) {
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_results_model (self);
}


void unity_scope_proxy_set_results_model (UnityScopeProxy* self, DeeSharedModel* value) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_results_model (self, value);
}


DeeSharedModel* unity_scope_proxy_get_global_results_model (UnityScopeProxy* self) {
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_global_results_model (self);
}


void unity_scope_proxy_set_global_results_model (UnityScopeProxy* self, DeeSharedModel* value) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_global_results_model (self, value);
}


DeeSharedModel* unity_scope_proxy_get_filters_model (UnityScopeProxy* self) {
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_filters_model (self);
}


void unity_scope_proxy_set_filters_model (UnityScopeProxy* self, DeeSharedModel* value) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_filters_model (self, value);
}


static void g_cclosure_user_marshal_VOID__STRING_BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_BOXED) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_BOXED callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_boxed (param_values + 2), data2);
}


static void unity_scope_proxy_base_init (UnityScopeProxyIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_boxed ("sources", "sources", "sources", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("search-in-global", "search-in-global", "search-in-global", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_object ("results-model", "results-model", "results-model", DEE_TYPE_SHARED_MODEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_object ("global-results-model", "global-results-model", "global-results-model", DEE_TYPE_SHARED_MODEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_object ("filters-model", "filters-model", "filters-model", DEE_TYPE_SHARED_MODEL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_signal_new ("search_finished", UNITY_TYPE_SCOPE_PROXY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_HASH_TABLE);
		g_signal_new ("global_search_finished", UNITY_TYPE_SCOPE_PROXY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_BOXED, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_HASH_TABLE);
	}
}


GType unity_scope_proxy_get_type (void) {
	static volatile gsize unity_scope_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&unity_scope_proxy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityScopeProxyIface), (GBaseInitFunc) unity_scope_proxy_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType unity_scope_proxy_type_id;
		unity_scope_proxy_type_id = g_type_register_static (G_TYPE_INTERFACE, "UnityScopeProxy", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (unity_scope_proxy_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&unity_scope_proxy_type_id__volatile, unity_scope_proxy_type_id);
	}
	return unity_scope_proxy_type_id__volatile;
}



